#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QLoggingCategory>

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    qSetMessagePattern(
                "%{time process} %{if-debug}D%{endif}%{if-warning}W%{endif}%{if-critical}C%{endif}%{if-fatal}F%{endif}] "
                "%{category} %{function} - %{message}");
    QLoggingCategory::setFilterRules(
                "qt.quick.mouse=true\n"
                "qt.quick.mouse.target=true\n"
                "qt.quick.touch.target=true\n"
                "qt.quick.touch=true\n"
                "qt.quick.pointer.grab=true\n"
                "qt.quick.pointer.events=true\n"
                "qt.quick.handler.tap=true\n"
                "qt.qpa.input.events=true\n"
                "qt.qpa.input=true\n");

    QGuiApplication app(argc, argv);

    QQmlApplicationEngine engine;
    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}
